--Klein, RotateNibbles step

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_rotnibbles IS
  PORT (
    mode_i : IN STD_LOGIC;
    b_in   : IN STD_LOGIC_VECTOR(63 DOWNTO 0); --output of subnibbles step
    c_out  : OUT STD_LOGIC_VECTOR(63 DOWNTO 0) --after rotate step
    );
END klein_rotnibbles;

ARCHITECTURE rtl OF klein_rotnibbles IS

BEGIN

  PROCESS(mode_i, b_in)
  BEGIN
    IF mode_i='0' THEN
      c_out(63 DOWNTO 48) <= b_in(15 DOWNTO 0);
      c_out(47 DOWNTO 0)  <= b_in(63 DOWNTO 16);
    ELSE
      c_out(15 DOWNTO 0)  <= b_in(63 DOWNTO 48);
      c_out(63 DOWNTO 16) <= b_in(47 DOWNTO 0);
    END IF;
  END PROCESS;
  
END rtl;

