--klein, subnibbles step

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_subnibbles IS
  PORT (
    byte_i : IN STD_LOGIC_VECTOR(0 to 7);
    byte_o : OUT STD_LOGIC_VECTOR(0 to 7)
    );
END klein_subnibbles;

ARCHITECTURE rtl OF klein_subnibbles IS

  COMPONENT klein_sbox IS
    PORT (
      a_in  : IN STD_LOGIC_VECTOR(0 to 3);
      a_out : OUT STD_LOGIC_VECTOR(0 to 3) 
      );
  END COMPONENT;
  
  
BEGIN

  i_klein_sbox1 : klein_sbox
    PORT MAP (
      a_in  => byte_i(0 to 3),
      a_out => byte_o(0 to 3)
      );

   i_klein_sbox2 : klein_sbox
    PORT MAP (
      a_in  => byte_i(4 to 7),
      a_out => byte_o(4 to 7)
      );

 END rtl;
