----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
--
-- Create Date:   15:35:54 11/04/2015
-- Design Name:   
-- Module Name:   /nhome/cmarcha2/Documents/ultralight/Klein/klein_v1/round_tb.vhd
-- Project Name:  Klein_v1
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: round
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
USE ieee.numeric_std.ALL;
 
ENTITY round_tb IS
END round_tb;
 
ARCHITECTURE behavior OF round_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT round
    PORT(
         clk_i : IN  std_logic;
         rstb_i : IN  std_logic;
         ena_ir : IN  std_logic;
         byte_i : IN  std_logic_vector(0 to 7);
         key_i : IN  std_logic_vector(0 to 7);
         byte_o : OUT  std_logic_vector(0 to 7)
        );
    END COMPONENT;
    

   --Inputs
   signal clk_i : std_logic := '0';
   signal rstb_i : std_logic := '0';
   signal byte_i : std_logic_vector(0 to 7) := (others => '0');
   signal key_i : std_logic_vector(0 to 7) := (others => '0');
   signal intern_count : std_logic_vector(3 downto 0) := (others => '0');

 	--Outputs
   signal byte_o : std_logic_vector(0 to 7);

   -- Clock period definitions
   constant clk_i_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: round PORT MAP (
          clk_i => clk_i,
          rstb_i => rstb_i,
          ena_ir => intern_count(2),
          byte_i => byte_i,
          key_i => key_i,
          byte_o => byte_o
        );

   -- Clock process definitions
   clk_i_process :process
   begin
		clk_i <= '1';
		wait for clk_i_period/2;
		clk_i <= '0';
		wait for clk_i_period/2;
   end process;
 
   c_proc : process(clk_i, rstb_i)
    begin
      if rstb_i = '0' then
        intern_count <= (others => '0');
      elsif rising_edge(clk_i) then
        intern_count <= std_logic_vector(unsigned(intern_count)+1);
      end if;
    end process;

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      byte_i <= x"ff";
      key_i  <= x"ab";
      wait for 50 ns;	
      rstb_i <= '1';
      key_i  <= x"90";
      wait for clk_i_period;
      key_i  <= x"78";
      wait for clk_i_period;
      key_i  <= x"56";
      wait for clk_i_period*5;
      key_i  <= x"34";
      wait for clk_i_period;
      key_i  <= x"12";
      wait for clk_i_period;
      key_i  <= x"ef";
      wait for clk_i_period;
      key_i  <= x"cd";
      -- insert stimulus here 

      wait;
   end process;

END;
